*** a/src/backend/libpq/auth.c
--- b/src/backend/libpq/auth.c
***************
*** 1665,1671 **** ident_inet(hbaPort *port)
  
  	sock_fd = socket(ident_serv->ai_family, ident_serv->ai_socktype,
  					 ident_serv->ai_protocol);
! 	if (sock_fd < 0)
  	{
  		ereport(LOG,
  				(errcode_for_socket_access(),
--- 1665,1671 ----
  
  	sock_fd = socket(ident_serv->ai_family, ident_serv->ai_socktype,
  					 ident_serv->ai_protocol);
! 	if (sock_fd == PGINVALID_SOCKET)
  	{
  		ereport(LOG,
  				(errcode_for_socket_access(),
***************
*** 1745,1751 **** ident_inet(hbaPort *port)
  					ident_response)));
  
  ident_inet_done:
! 	if (sock_fd >= 0)
  		closesocket(sock_fd);
  	pg_freeaddrinfo_all(remote_addr.addr.ss_family, ident_serv);
  	pg_freeaddrinfo_all(local_addr.addr.ss_family, la);
--- 1745,1751 ----
  					ident_response)));
  
  ident_inet_done:
! 	if (sock_fd != PGINVALID_SOCKET)
  		closesocket(sock_fd);
  	pg_freeaddrinfo_all(remote_addr.addr.ss_family, ident_serv);
  	pg_freeaddrinfo_all(local_addr.addr.ss_family, la);
***************
*** 2563,2569 **** CheckRADIUSAuth(Port *port)
  	packet->length = htons(packet->length);
  
  	sock = socket(serveraddrs[0].ai_family, SOCK_DGRAM, 0);
! 	if (sock < 0)
  	{
  		ereport(LOG,
  				(errmsg("could not create RADIUS socket: %m")));
--- 2563,2569 ----
  	packet->length = htons(packet->length);
  
  	sock = socket(serveraddrs[0].ai_family, SOCK_DGRAM, 0);
! 	if (sock == PGINVALID_SOCKET)
  	{
  		ereport(LOG,
  				(errmsg("could not create RADIUS socket: %m")));
*** a/src/backend/libpq/pqcomm.c
--- b/src/backend/libpq/pqcomm.c
***************
*** 392,398 **** StreamServerPort(int family, char *hostName, unsigned short portNumber,
  				break;
  		}
  
! 		if ((fd = socket(addr->ai_family, SOCK_STREAM, 0)) < 0)
  		{
  			ereport(LOG,
  					(errcode_for_socket_access(),
--- 392,398 ----
  				break;
  		}
  
! 		if ((fd = socket(addr->ai_family, SOCK_STREAM, 0)) == PGINVALID_SOCKET)
  		{
  			ereport(LOG,
  					(errcode_for_socket_access(),
***************
*** 632,638 **** StreamConnection(pgsocket server_fd, Port *port)
  	port->raddr.salen = sizeof(port->raddr.addr);
  	if ((port->sock = accept(server_fd,
  							 (struct sockaddr *) & port->raddr.addr,
! 							 &port->raddr.salen)) < 0)
  	{
  		ereport(LOG,
  				(errcode_for_socket_access(),
--- 632,638 ----
  	port->raddr.salen = sizeof(port->raddr.addr);
  	if ((port->sock = accept(server_fd,
  							 (struct sockaddr *) & port->raddr.addr,
! 							 &port->raddr.salen)) == PGINVALID_SOCKET)
  	{
  		ereport(LOG,
  				(errcode_for_socket_access(),
*** a/src/backend/postmaster/postmaster.c
--- b/src/backend/postmaster/postmaster.c
***************
*** 2165,2171 **** ConnCreate(int serverFd)
  
  	if (StreamConnection(serverFd, port) != STATUS_OK)
  	{
! 		if (port->sock >= 0)
  			StreamClose(port->sock);
  		ConnFree(port);
  		return NULL;
--- 2165,2171 ----
  
  	if (StreamConnection(serverFd, port) != STATUS_OK)
  	{
! 		if (port->sock != PGINVALID_SOCKET)
  			StreamClose(port->sock);
  		ConnFree(port);
  		return NULL;
